summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2012-02-01 21:42:45 +0100
committerJim Meyering <meyering@redhat.com>2012-02-12 12:21:53 +0100
commitb01355a1dc4939a3967ee82ac0a6dd19702778c3 (patch)
treea8f6534979bebdda6d60a5985d9a7094322ae95b /tests
parent31eeead93842c6581e0a9b21f6e8eb964d0c9309 (diff)
downloadcoreutils-b01355a1dc4939a3967ee82ac0a6dd19702778c3.tar.xz
mv: "mv A B" would sometimes succeed, yet A would remain, ...
But only when both A and B were hard links to the same symlink. * src/copy.c (same_file_ok): Handle another special case: the one in which we are moving a symlink onto a hard link to itself. In this case, we must explicitly tell the caller to unlink the source file. Otherwise, at least the linux-3.x kernel rename function would do nothing, as mandated by POSIX 2008. * tests/mv/symlink-onto-hardlink-to-self: New test. * tests/Makefile.am (TESTS): Add it. * NEWS (Bug fixes): Mention it. Reported by Bernhard Voelker in http://bugs.gnu.org/10686
Diffstat (limited to 'tests')
-rw-r--r--tests/Makefile.am1
-rwxr-xr-xtests/mv/symlink-onto-hardlink-to-self56
2 files changed, 57 insertions, 0 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index a94aaa26f..c951f69a1 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -492,6 +492,7 @@ TESTS = \
mv/partition-perm \
mv/perm-1 \
mv/symlink-onto-hardlink \
+ mv/symlink-onto-hardlink-to-self \
mv/to-symlink \
mv/trailing-slash \
mv/update \
diff --git a/tests/mv/symlink-onto-hardlink-to-self b/tests/mv/symlink-onto-hardlink-to-self
new file mode 100755
index 000000000..f53f6ef44
--- /dev/null
+++ b/tests/mv/symlink-onto-hardlink-to-self
@@ -0,0 +1,56 @@
+#!/bin/sh
+# Demonstrate that when moving a symlink onto a hardlink-to-that-symlink, the
+# source symlink is removed. Depending on your kernel (e.g., Linux, Solaris,
+# but not NetBSD), prior to coreutils-8.16, the mv would successfully perform
+# a no-op. I.e., surprisingly, mv s1 s2 would succeed, yet fail to remove s1.
+
+# Copyright (C) 2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ mv
+
+# Create a file f, and a symlink s1 to that file.
+touch f || framework_failure_
+ln -s f s2 || framework_failure_
+
+for opt in '' --backup; do
+
+ # Attempt to create a hard link to that symlink.
+ # On some systems, it's not possible: they create a hard link to the referent.
+ ln s2 s1 || framework_failure_
+
+ # If s1 is not a symlink, skip this test.
+ test -h s1 \
+ || skip_ your kernel or file system cannot create a hard link to a symlink
+
+ mv $opt s1 s2 > out 2>&1 || fail=1
+ compare /dev/null out || fail=1
+
+ # Ensure that s1 is gone.
+ test -e s1 && fail=1
+
+ if test "$opt" = --backup; then
+ # With --backup, ensure that the backup file was created.
+ ref=$(readlink s2~) || fail=1
+ test "$ref" = f || fail=1
+ else
+ # Without --backup, ensure there is no backup file.
+ test -e s2~ && fail=1
+ fi
+
+done
+
+Exit $fail